## xtensor 0.27.1

=== CMakeLists.txt ===
############################################################################
# Copyright (c) Johan Mabille, Sylvain Corlay and Wolf Vollprecht          #
# Copyright (c) QuantStack                                                 #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.15..3.29)
project(xtensor CXX)

set(XTENSOR_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)

# xtensor tag files
set(XTENSOR_DATA_DIR "share/xeus-cpp")
set(XTENSOR_TAGFILES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/share/xeus-cpp/tagfiles)

set(XTENSOR_CONF_DIR "etc/xeus-cpp")
set(XTENSOR_TAGCONFS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/etc/xeus-cpp/tags.d)

file(COPY "${XTENSOR_TAGFILES_DIR}" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/share/xeus-cpp")
file(COPY "${XTENSOR_TAGCONFS_DIR}" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/etc/xeus-cpp")


# Versionning
# ===========

file(STRINGS "${XTENSOR_INCLUDE_DIR}/xtensor/core/xtensor_config.hpp" xtensor_version_defines
     REGEX "#define XTENSOR_VERSION_(MAJOR|MINOR|PATCH)")
foreach(ver ${xtensor_version_defines})
    if(ver MATCHES "#define XTENSOR_VERSION_(MAJOR|MINOR|PATCH) +([^ ]+)$")
        set(XTENSOR_VERSION_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()
set(${PROJECT_NAME}_VERSION
    ${XTENSOR_VERSION_MAJOR}.${XTENSOR_VERSION_MINOR}.${XTENSOR_VERSION_PATCH})
message(STATUS "Building xtensor v${${PROJECT_NAME}_VERSION}")

# Dependencies
# ============

set(xtl_REQUIRED_VERSION 0.8.0)
if(TARGET xtl)
    set(xtl_VERSION ${XTL_VERSION_MAJOR}.${XTL_VERSION_MINOR}.${XTL_VERSION_PATCH})
    # Note: This is not SEMVER compatible comparison
    if(${xtl_VERSION} VERSION_LESS ${xtl_REQUIRED_VERSION})
        message(ERROR "Mismatch xtl versions. Found '${xtl_VERSION}' but requires: '${xtl_REQUIRED_VERSION}'")
    else()
        message(STATUS "Found xtl v${xtl_VERSION}")
    endif()
else()
    find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
    message(STATUS "Found xtl: ${xtl_INCLUDE_DIRS}/xtl")
endif()

find_package(nlohmann_json 3.1.1 QUIET)

# Optional dependencies
# =====================

OPTION(XTENSOR_USE_XSIMD "simd acceleration for xtensor" OFF)
OPTION(XTENSOR_USE_TBB "enable parallelization using intel TBB" OFF)
OPTION(XTENSOR_USE_OPENMP "enable parallelization using OpenMP" OFF)
if(XTENSOR_USE_TBB AND XTENSOR_USE_OPENMP)
    message(
        FATAL
        "XTENSOR_USE_TBB and XTENSOR_USE_OPENMP cannot both be active at once"
    )
endif()

if(XTENSOR_USE_XSIMD)
    set(xsimd_REQUIRED_VERSION 13.2.0)
    if(TARGET xsimd)
        set(xsimd_VERSION ${XSIMD_VERSION_MAJOR}.${XSIMD_VERSION_MINOR}.${XSIMD_VERSION_PATCH})
        # Note: This is not SEMVER compatible comparison
        if(${xsimd_VERSION} VERSION_LESS ${xsimd_REQUIRED_VERSION})
            message(ERROR "Mismatch xsimd versions. Found '${xsimd_VERSION}' but requires: '${xsimd_REQUIRED_VERSION}'")
        else()
            message(STATUS "Found xsimd v${xsimd_VERSION}")
        endif()
    else()
        find_package(xsimd ${xsimd_REQUIRED_VERSION} REQUIRED)
        message(STATUS "Found xsimd: ${xsimd_INCLUDE_DIRS}/xsimd")
    endif()
endif()

if(XTENSOR_USE_TBB)
    set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
    find_package(TBB REQUIRED)
    message(STATUS "Found intel TBB: ${TBB_INCLUDE_DIRS}")
endif()

if(XTENSOR_USE_OPENMP)
    find_package(OpenMP REQUIRED)
    if (OPENMP_FOUND)
        # Set openmp variables now

        # Create private target just for this lib
        # https://cliutils.gitlab.io/modern-cmake/chapters/packages/OpenMP.html
        # Probably not safe for cmake < 3.4 ..
        find_package(Threads REQUIRED)
        add_library(OpenMP::OpenMP_CXX_xtensor IMPORTED INTERFACE)
        set_property(
            TARGET
            OpenMP::OpenMP_CXX_xtensor
            PROPERTY
            INTERFACE_COMPILE_OPTIONS ${OpenMP_CXX_FLAGS}
        )
        # Only works if the same flag is passed to the linker; use CMake 3.9+ otherwise (Intel, AppleClang)
        set_property(
            TARGET
            OpenMP::OpenMP_CXX_xtensor
            PROPERTY
            INTERFACE_LINK_LIBRARIES ${OpenMP_CXX_FLAGS} Threads::Threads)

        message(STATUS "OpenMP Found")
    else()
        message(FATAL "Failed to locate OpenMP")
    endif()
endif()

# Build
# =====

set(XTENSOR_HEADERS
    ${XTENSOR_INCLUDE_DIR}/xtensor/chunk/xchunked_array.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/chunk/xchunked_assign.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/chunk/xchunked_view.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/containers/xadapt.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/containers/xarray.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/containers/xbuffer_adaptor.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/containers/xcontainer.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/containers/xfixed.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/containers/xscalar.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/containers/xstorage.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/containers/xtensor.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xaccessible.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xassign.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xeval.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xexpression.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xexpression_traits.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xfunction.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xiterable.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xiterator.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xlayout.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xmath.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xmultiindex_iterator.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xnoalias.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xoperation.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xsemantic.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xshape.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xstrides.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xtensor_config.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xtensor_forward.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/core/xvectorize.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/generators/xbuilder.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/generators/xgenerator.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/generators/xrandom.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/io/xcsv.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/io/xinfo.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/io/xio.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/io/xjson.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/io/xmime.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/io/xnpy.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/misc/xcomplex.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/misc/xexpression_holder.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/misc/xfft.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/misc/xhistogram.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/misc/xmanipulation.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/misc/xpad.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/misc/xset_operation.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/misc/xsort.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/optional/xoptional.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/optional/xoptional_assembly.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/optional/xoptional_assembly_base.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/optional/xoptional_assembly_storage.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/reducers/xaccumulator.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/reducers/xblockwise_reducer.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/reducers/xblockwise_reducer_functors.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/reducers/xnorm.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/reducers/xreducer.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/utils/xexception.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/utils/xtensor_simd.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/utils/xutils.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xaxis_iterator.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xaxis_slice_iterator.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xbroadcast.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xdynamic_view.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xfunctor_view.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xindex_view.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xmasked_view.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xoffset_view.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xrepeat.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xslice.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xstrided_view.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xstrided_view_base.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xview.hpp
    ${XTENSOR_INCLUDE_DIR}/xtensor/views/xview_utils.hpp
)

add_library(xtensor INTERFACE)

target_include_directories(xtensor INTERFACE
    $<BUILD_INTERFACE:${XTENSOR_INCLUDE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:include>)

target_compile_features(xtensor INTERFACE cxx_std_20)

target_link_libraries(xtensor INTERFACE xtl)

OPTION(XTENSOR_ENABLE_ASSERT "xtensor bound check" OFF)
OPTION(XTENSOR_CHECK_DIMENSION "xtensor dimension check" OFF)
OPTION(XTENSOR_FORCE_TEMPORARY_MEMORY_IN_ASSIGNMENTS "xtensor force the use of temporary memory when assigning instead of an automatic overlap check" ON)
OPTION(BUILD_TESTS "xtensor test suite" OFF)
OPTION(BUILD_BENCHMARK "xtensor benchmark" OFF)
OPTION(DOWNLOAD_GBENCHMARK "download google benchmark and build from source" ON)
OPTION(DEFAULT_COLUMN_MAJOR "set default layout to column major" OFF)
OPTION(CPP23 "enables C++23 (experimental)" OFF)
OPTION(XTENSOR_DISABLE_EXCEPTIONS "Disable C++ exceptions" OFF)
OPTION(DISABLE_MSVC_ITERATOR_CHECK "Disable the MVSC iterator check" ON)


if(XTENSOR_ENABLE_ASSERT OR XTENSOR_CHECK_DIMENSION)
    add_definitions(-DXTENSOR_ENABLE_ASSERT)
endif()

if(XTENSOR_CHECK_DIMENSION)
    add_definitions(-DXTENSOR_ENABLE_CHECK_DIMENSION)
endif()

if(XTENSOR_FORCE_TEMPORARY_MEMORY_IN_ASSIGNMENTS)
    add_definitions(-DXTENSOR_FORCE_TEMPORARY_MEMORY_IN_ASSIGNMENTS)
endif()

if(DEFAULT_COLUMN_MAJOR)
    add_definitions(-DXTENSOR_DEFAULT_LAYOUT=layout_type::column_major)
endif()

if(MSVC AND DISABLE_MSVC_ITERATOR_CHECK)
    add_compile_definitions($<$<CONFIG:Debug>:_ITERATOR_DEBUG_LEVEL=0>)
endif()

if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()

if(BUILD_BENCHMARK)
    add_subdirectory(benchmark)
endif()

if(XTENSOR_USE_OPENMP)
    # Link xtensor itself to OpenMP to propagate to user projects
    target_link_libraries(xtensor INTERFACE OpenMP::OpenMP_CXX_xtensor)
endif()

# Installation
# ============

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

install(TARGETS xtensor
        EXPORT ${PROJECT_NAME}-targets)

# Makes the project importable from the build directory
export(EXPORT ${PROJECT_NAME}-targets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")

install(DIRECTORY ${XTENSOR_INCLUDE_DIR}/xtensor
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

set(XTENSOR_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_DATADIR}/cmake/${PROJECT_NAME}" CACHE
    STRING "install path for xtensorConfig.cmake")

configure_package_config_file(${PROJECT_NAME}Config.cmake.in
                              "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
                              INSTALL_DESTINATION ${XTENSOR_CMAKECONFIG_INSTALL_DIR})

# xtensor is header-only and does not depend on the architecture.
# Remove CMAKE_SIZEOF_VOID_P from xtensorConfigVersion.cmake so that an xtensorConfig.cmake
# generated for a 64 bit target can be used for 32 bit targets and vice versa.
set(_XTENSOR_CMAKE_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})
unset(CMAKE_SIZEOF_VOID_P)
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake

=== debian/changelog ===
xtensor (0.27.1-2) unstable; urgency=medium

  * debian/tests on i386: add -DMARK_FLAKEY_TEST to CXXFLAGS not cmake option
    CMAKE_CXX_FLAGS to avoid wiping other options set in CXXFLAGS
    (-DXTENSOR_FORCE_TEMPORARY_MEMORY_IN_ASSIGNMENTS in particular)

 -- Drew Parsons <dparsons@debian.org>  Tue, 10 Feb 2026 22:52:57 +0100

xtensor (0.27.1-1) unstable; urgency=medium

  * New upstream release
    - update versioned Build-Depends: xtl-dev (>= 0.8.0~),
      cmake (>= 3.15)
    - applies or deprecates debian patches clang19_feature_check.patch
      and test_xinfo_no_clang.patch
    - provides xeus-cpp config files
  * drop xsimd support until compatible xsimd version is available
    (see Bug#1061243)
  * debian patch install_sysconfdir.patch installs etc/xeus-cpp config
    files in CMAKE_INSTALL_SYSCONFDIR to get /etc installed separately
    from /usr when CMAKE_INSTALL_PREFIX=/usr (set by debhelper cmake)
  * debian/libxtensor-dev.install prepend debian/tmp in front of the
    etc/xeus-cpp config file to work around Bug#1127452 in dh_missing
  * debian patch docs_intersphinx.patch uses local objects.inv to
    reference numpy and scipy docs.
    Build-Depends-Indep: python-numpy-doc, python-scipy-doc <!nodoc>
  * Build-Depends-Indep: texlive <!nodoc> (for latex)
  * debian/tests: set -DXTENSOR_FORCE_TEMPORARY_MEMORY_IN_ASSIGNMENTS
    explicitly to avoid binding reference errors. See upstream #2887.
  * update debian/watch to v5 GitHub template
  * Standards-Version: 4.7.3

 -- Drew Parsons <dparsons@debian.org>  Mon, 09 Feb 2026 18:38:05 +0100

=== debian/control ===
Source: xtensor
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake (>= 3.15),
 debhelper-compat (= 13),
 dpkg-dev (>= 1.17.14),
 doctest-dev <!nocheck>,
 nlohmann-json3-dev (>= 3.1.1~),
 xtl-dev (>= 0.8.0~),
# libxsimd-dev (>= 13.2.0~) [!arm64 !armel !armhf !ppc64el !riscv64 !s390x],
 python3-sphinx
Build-Depends-Indep: python3-breathe <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>,
 graphviz <!nodoc>,
 texlive <!nodoc>,
 libjs-mathjax <!nodoc>,
 python-numpy-doc <!nodoc>,
 python-scipy-doc <!nodoc>
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/science-team/xtensor
Vcs-Git: https://salsa.debian.org/science-team/xtensor.git
Homepage: https://github.com/xtensor-stack/xtensor

Package: libxtensor-dev
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: xtl-dev (>= 0.8.0~),
 nlohmann-json3-dev (>= 3.1.1~),
 ${misc:Depends}
#Recommends: libxsimd-dev (>= 13.2.0~)
Suggests: xtensor-doc <!nodoc>
Breaks: xtensor-dev (<< 0.22.0-4~)
Replaces: xtensor-dev (<< 0.22.0-4~)
Description: multi-dimensional arrays with broadcasting and lazy computing
 xtensor is a C++ library meant for numerical analysis with multi-dimensional
 array expressions.
 .
 xtensor provides:
 .
   - an extensible expression system enabling lazy broadcasting.
   - an API following the idioms of the C++ standard library.
   - tools to manipulate array expressions and build upon xtensor.
 .
 Containers of xtensor are inspired by NumPy, the Python array programming
 library. In fact, xtensor can be used to process numpy data structures inplace
 using Python's buffer protocol. For more details on the numpy bindings, check
 out the xtensor-python project.
 .
 This package provides the header-only library.

Package: xtensor-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
 ${sphinxdoc:Depends},
 libjs-mathjax
Built-Using: ${sphinxdoc:Built-Using}
Description: documentation for xtensor
 xtensor is a C++ library meant for numerical analysis with multi-dimensional
 array expressions.
 .
 xtensor provides:
 .
   - an extensible expression system enabling lazy broadcasting.
   - an API following the idioms of the C++ standard library.
   - tools to manipulate array expressions and build upon xtensor.
 .
 Containers of xtensor are inspired by NumPy, the Python array programming
 library. In fact, xtensor can be used to process numpy data structures inplace
 using Python's buffer protocol. For more details on the numpy bindings, check
 out the xtensor-python project.
 .
 This package provides the documentation.
Build-Profiles: <!nodoc>

Package: xtensor-dev
Architecture: all
Section: libdevel
Depends: libxtensor-dev, ${misc:Depends}
Description: multi-dimensional arrays with broadcasting (transition package)
 xtensor is a C++ library meant for numerical analysis with multi-dimensional
 array expressions.
 .
 This is a dummy package transitioning to libxtensor-dev.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  BUILD_OPTIONS += -DBUILD_TESTS=ON
else
  BUILD_OPTIONS += -DBUILD_TESTS=OFF
endif

# libxsimd-dev is available on some arches such as arm64, i386, m68k,
# So explicitly switch xsimd support off except for arches where it is known to work reliably.
# See also Bugs #1053090, #1053854
# ...but deactivate until compatible xsimd version is available, Bug#1061243
#XSIMD_ARCH_LIST := amd64 i386 kfreebsd
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(XSIMD_ARCH_LIST)$(space)))
  BUILD_OPTIONS += -DXTENSOR_USE_XSIMD=ON
else
  BUILD_OPTIONS += -DXTENSOR_USE_XSIMD=OFF
endif

# try to avoid exhausting virtual memory on small-memory arches
SMALL_MEM_ARCH_LIST := armel mipsel hurd-i386
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SMALL_MEM_ARCH_LIST)$(space)))
  export DEB_CXXFLAGS_MAINT_APPEND = -Os -g0
endif

# mark i386 as having flakey tests (xreducer.average)
FLAKEY_TEST_ARCH_LIST := i386
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(FLAKEY_TEST_ARCH_LIST)$(space)))
  export DEB_CXXFLAGS_MAINT_APPEND = -DMARK_FLAKEY_TEST
endif


%:
	dh $@ --with sphinxdoc

override_dh_auto_clean-indep:
	dh_auto_clean
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C docs clean
endif
	rm -rf docs/build docs/html

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_OPTIONS)

override_dh_auto_build-indep: export http_proxy=127.0.0.1:9
override_dh_auto_build-indep: export https_proxy=127.0.0.1:9
override_dh_auto_build-indep:
	dh_auto_build
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C docs html
endif

override_dh_auto_build-arch:
	dh_auto_build -a $(DH_AUTO_BUILD_OPTIONS)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	CTEST_OUTPUT_ON_FAILURE=1 dh_auto_test -- xtest
endif

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

get-orig-source:
	uscan --download-current-version --force-download --no-symlink

=== debian/tests/control ===
Tests: test-xtensor
Depends: cmake,
         g++,
         doctest-dev,
         libxtensor-dev,
#         libxsimd-dev (>= 13.2.0~) [!arm64 !armel !armhf !ppc64el !riscv64 !s390x],
#         libxsimd-dev (<< 14) [!arm64 !armel !armhf !ppc64el !riscv64 !s390x]
Restrictions: allow-stderr

Tests: test-xtensor-clang
Depends: clang,
         cmake,
         doctest-dev,
         libxtensor-dev,
#         libxsimd-dev (>= 13.2.0~) [!arm64 !armel !armhf !ppc64el !riscv64 !s390x],
#         libxsimd-dev (<< 14) [!arm64 !armel !armhf !ppc64el !riscv64 !s390x]
Restrictions: allow-stderr

=== debian/watch ===
Version: 5

Template: GitHub
Owner: xtensor-stack
Project: xtensor
